package MT::Plugin::SKR::MobileAgent;
use strict;
use base qw( MT::Plugin );
use String::CamelCase qw(camelize);
use Class::Inspector;
use MobileAgent::Tags;

our $PLUGIN_NAME = 'MobileAgent';
our $VERSION = '0.01';

my $plugin = __PACKAGE__->new({
    name     => $PLUGIN_NAME,
    version  => $VERSION,
    key      => lc $PLUGIN_NAME,
    id       => lc $PLUGIN_NAME,
    author_name => 'SKYARC System Co.,Ltd.',
    author_link => 'http://www.skyarc.co.jp/',
    description => q{<MT_TRANS phrase="MobileAgent">},
    l10n_class  => $PLUGIN_NAME. '::L10N',
});

MT->add_plugin( $plugin );

sub init_registry {
    my $plugin = shift;

    my %tag_type = (
        co_ => 'block',
        ft_ => 'function',
        bt_ => 'block',
        mo_ => 'modifier',
    );

    my $subs = Class::Inspector->functions('MobileAgent::Tags');

    my $tags;
    for my $subname (@$subs) {
        while(my($key, $value) = each %tag_type){
            if($subname =~ m/^$key(.*?)$/){
                my $tag_name = camelize($1);
                $tag_name .= '?' if $key eq 'co_';
                $tags->{$value}->{$PLUGIN_NAME . $tag_name} = 'MobileAgent::Tags::' . $subname;
            }
        }
    }

    $plugin->registry({tags => $tags});
}

1;
__END__ 
