package MobileAgent::Tags;
use strict;
use warnings;
use HTTP::MobileAgent;
use HTTP::MobileAgent::Plugin::Charset;

sub bt_ {
    my ($ctx, $args, $cond) = @_;

    unless($ctx->stash('mobile_agent')){
        my $agent = HTTP::MobileAgent->new;
        $ctx->stash('mobile_agent', $agent);
    }

    my $builder = $ctx->stash('builder');
    my $tokens  = $ctx->stash('tokens');
    defined (my $out = $builder->build ($ctx, $tokens, $cond))
        or return $ctx->error ($builder->errstr);
    return $out;
}

sub co_if_non_mobile { 
    my ($ctx, $args) = @_;
    my $agent = $ctx->stash('mobile_agent') or return;
    return $agent->is_non_mobile;
}

sub co_if_docomo {
    my ($ctx, $args) = @_;
    my $agent = $ctx->stash('mobile_agent') or return;
    return $agent->is_docomo;
}

sub co_if_vodafone {
    my ($ctx, $args) = @_;
    my $agent = $ctx->stash('mobile_agent') or return;
    return $agent->is_vodafone;
}

sub co_if_ezweb {
    my ($ctx, $args) = @_;
    my $agent = $ctx->stash('mobile_agent') or return;
    return $agent->is_ezweb;
}

sub ft_encoding {
    my ($ctx, $args) = @_;
    my $agent = $ctx->stash('mobile_agent') or return;
    return $agent->encoding;
}

sub ft_name {
    my ($ctx, $args) = @_;
    my $agent = $ctx->stash('mobile_agent') or return;
    return $agent->name;
}

sub ft_carrier {
    my ($ctx, $args) = @_;
    my $agent = $ctx->stash('mobile_agent') or return;
    return $agent->carrier;
}

sub ft_user_id {
    my ($ctx, $args) = @_;
    my $agent = $ctx->stash('mobile_agent') or return;
    return $agent->user_id; 
}

1;
__END__

